/*
hola metido, que haces revisando mi codigo xd. no hay problema :) usalo cuanto quieras no nesesito creditos ni ninguna tonteria saludos. 
Recuerda comer tacos todos los dias.
*/

import {
    world,
    system,
    EntityComponentTypes
} from "@minecraft/server";

function getUniqueBlockProperty(block) {
    return `crafting_traps:icePlace_${block.location.x}_${block.location.y}_${block.location.z}`;
}

function onstep(data) {
    const { entity, block, dimension } = data;

    const fakeBlockEffects = {
        "crafting_traps:fake_dirt": ["dig.grass", "crafting_traps:destroy_block_dirt"],
        "crafting_traps:fake_grass": ["dig.grass", "crafting_traps:destroy_block_grass"],
        "crafting_traps:fake_stone": ["dig.stone", "crafting_traps:destroy_block_stone"],
        "crafting_traps:fake_cobblestone": ["dig.stone", "crafting_traps:destroy_block_cobblestone"],
        "crafting_traps:fake_cobblestone_mossy": ["dig.stone", "crafting_traps:destroy_block_cobblestone_mossy"]
    };

    if (block.typeId in fakeBlockEffects) {
        const [sound, particle] = fakeBlockEffects[block.typeId];
        handleFakeBlock(block, dimension, sound, particle, entity);
    }
    if (block.typeId === "crafting_traps:ice_trap") {
        placeBlocksIce(block, dimension);
    }
    if (block.typeId === "crafting_traps:underworld_trap") {
        underworld(entity, block, dimension);
    }
    if (block.typeId === "crafting_traps:lift_trap") {
        lift_trap(entity, block, dimension);
    }

    if (block.typeId === "crafting_traps:firetrap") {
        spawnParticleFire(entity, block, dimension);
    }
    if (block.typeId.startsWith("crafting_traps:mine_")) {
        explosiveMineBlock(dimension, entity);
    }
}

function onstepOff(data) {
    const { entity, block, dimension } = data;

    if (block.typeId === "crafting_traps:ice_trap") {
        breakBlocksIce(block, dimension);
    }

    if (block.typeId === "crafting_traps:lift_trap") {
        lift_trapOff(entity, block, dimension);
    }
}

function placeBlocksIce(block, dimension) {
    for (let i = 1; i < 3; i++) {
        const blockPlace = dimension.getBlock({ x: block.location.x, y: block.location.y + i, z: block.location.z });
        if (blockPlace.isAir) {
            blockPlace.setType("minecraft:powder_snow");
            world.setDynamicProperty(getUniqueBlockProperty(blockPlace), blockPlace.location);
        }
    }
}

function breakBlocksIce(block, dimension) {
    for (let i = 1; i < 3; i++) {
        const blockPlace = dimension.getBlock({ x: block.location.x, y: block.location.y + i, z: block.location.z });
        if (!blockPlace.isAir) {
            blockPlace.setType("minecraft:air");
            world.setDynamicProperty(getUniqueBlockProperty(blockPlace), null);
        }
    }
}

function replaceMissingBlocks() {
    const dynamicPropertyIds = world.getDynamicPropertyIds();
    dynamicPropertyIds.forEach(property => {
        if (property.startsWith("crafting_traps:icePlace_")) {
            const locationData = world.getDynamicProperty(property);
            if (locationData == null) return;
            const block = world.getDimension("overworld").getBlock(locationData);
            try {
                if (block.isAir) {
                    block.setType("minecraft:powder_snow");
                }

                const adjacentLocations = [
                    { x: locationData.x + 1, z: locationData.z },
                    { x: locationData.x - 1, z: locationData.z },
                    { x: locationData.x, z: locationData.z + 1 },
                    { x: locationData.x, z: locationData.z - 1 }
                ];

                adjacentLocations.forEach(adjLoc => {
                    const adjacentBlock = world.getDimension("overworld").getBlock({ x: adjLoc.x, y: locationData.y, z: adjLoc.z });
                    if (adjacentBlock.typeId === "minecraft:powder_snow") {
                        adjacentBlock.setType("minecraft:air");
                    }
                });
            } catch (error) { }
        }
    });
}

function handleFakeBlock(block, dimension, sound, particle, entity) {
    const blockPlace = dimension.getBlock({ x: block.location.x, y: block.location.y, z: block.location.z });
    if (!blockPlace.isAir) {
        blockPlace.setType("minecraft:air");
        entity.runCommand(`playsound block.fake_block.break @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z}`);
        dimension.spawnParticle(particle, {
            x: block.location.x + 0.5, y: block.location.y + 1, z: block.location.z + 0.5
        });
    }
}

function spawnParticleFire(entity, block, dimension) {
    entity.runCommand(`playsound block.fire_trap.step @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
    dimension.spawnParticle("crafting_traps:firestorm", {
        x: block.location.x + 0.5, y: block.location.y + 1, z: block.location.z + 0.5
    });
    let i = 1;
    const blockPlace = dimension.getBlock({ x: block.location.x, y: block.location.y + i, z: block.location.z });
    if (blockPlace.isAir) {
        system.runTimeout(() => {
            blockPlace.setType("minecraft:fire");
        }, 10);
        system.runTimeout(() => {
            blockPlace.setType("minecraft:air");
        }, 35);
    }
}

function lift_trap(entity, block, dimension) {
    entity.runCommand(`playsound block.lift_trap.step @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
    block.setPermutation(block.permutation.withState("crafting_traps:boing", true));
    entity.addEffect("levitation", 10, { amplifier: 20, showParticles: false });
}

function lift_trapOff(entity, block, dimension) {
    block.setPermutation(block.permutation.withState("crafting_traps:boing", false));
}

function underworld(entity, block, dimension) {
    if (dimension.typeId === "minecraft:overworld") {
        entity.runCommand(`playsound block.underworld_trap.step @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
        entity.teleport({ x: block.location.x, y: -50, z: block.location.z });
    }else {
        entity.runCommand(`playsound block.underworld_trap.step @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
        entity.teleport({ x: block.location.x, y: 4, z: block.location.z });
    }
}


function gas() {
    const dimensions = ["overworld", "nether", "the_end"];
    dimensions.forEach(dimensionName => {
        const dimension = world.getDimension(dimensionName);
        dimension.getEntities().forEach(entity => {
            const y = entity.location.y;
            if ((entity.dimension.typeId === "minecraft:overworld" && y >= -63 && y <= 319) || 
                (entity.dimension.typeId !== "minecraft:overworld" && y >= 1 && y <= 125)) {
                
                const gasBlock = dimension.getBlock({ x: entity.location.x, y: y, z: entity.location.z });
                if (gasBlock && gasBlock.typeId === 'crafting_traps:gas_trap') {
                    let lastSoundTick = entity.getDynamicProperty("lastGasSoundTick") || 0;
                    let currentTick = system.currentTick;
                    if (currentTick - lastSoundTick >= 10) {
                        entity.runCommand(`playsound block.gas_trap.step @a[r=4] ${gasBlock.location.x} ${gasBlock.location.y} ${gasBlock.location.z} 1 1`);
                        entity.setDynamicProperty("lastGasSoundTick", currentTick);
                    }
                    entity.addEffect("fatal_poison", 60, { amplifier: 2, showParticles: false });
                }
            }
        });
    });
}



function crushing_trap(data) {
    const { block, dimension } = data;
    const direction = block.permutation.getState("minecraft:cardinal_direction");
    let x = 0;
    let z = 0;

    switch (direction) {
        case 'north':
            x = 0;
            z = 1;
            break;
        case 'south':
            x = 0;
            z = -1;
            break;
        case 'west':
            x = 1;
            z = 0;
            break;
        case 'east':
            x = -1;
            z = 0;
            break;
    }
    const blockAir = dimension.getBlock({ x: block.location.x + x, y: block.location.y, z: block.location.z + z });
    if (blockAir && blockAir.typeId !== 'minecraft:air' && blockAir.typeId !== 'minecraft:barrier') return;
    const location = { x: block.location.x + 0.5, y: block.location.y, z: block.location.z + 0.5 };
    const directions = [
        { x: block.location.x + 1, y: block.location.y, z: block.location.z },
        { x: block.location.x - 1, y: block.location.y, z: block.location.z },
        { x: block.location.x, y: block.location.y + 1, z: block.location.z },
        { x: block.location.x, y: block.location.y - 1, z: block.location.z },
        { x: block.location.x, y: block.location.y, z: block.location.z + 1 },
        { x: block.location.x, y: block.location.y, z: block.location.z - 1 }
    ];

    let foundActive = false;

    for (const coords of directions) {
        const adjacentBlock = dimension.getBlock(coords);
        if (adjacentBlock) {
            const typeId = adjacentBlock.typeId;

            const isActive = (
                (typeId === 'minecraft:lever' && adjacentBlock.permutation.getState("open_bit")) ||
                (typeId === 'minecraft:observer' && adjacentBlock.permutation.getState("powered_bit")) ||
                (typeId === 'minecraft:daylight_detector' && adjacentBlock.permutation.getState("redstone_signal") > 0) ||
                (typeId === 'minecraft:daylight_detector_inverted' && adjacentBlock.permutation.getState("redstone_signal") > 0) ||
                (typeId === 'minecraft:redstone_wire' && adjacentBlock.permutation.getState("redstone_signal") > 0) ||
                typeId === 'minecraft:powered_repeater' ||
                typeId === 'minecraft:powered_comparator' ||
                (typeId === 'minecraft:redstone_torch' && (coords.y === block.location.y || coords.y === block.location.y - 1)) ||
                typeId === 'minecraft:redstone_block' ||
                (typeId.endsWith('_pressure_plate') && adjacentBlock.permutation.getState("redstone_signal") > 0)
            );
            if (isActive) {
                foundActive = true;
                const crushing_trap = dimension.getEntities({
                    type: "crafting_traps:crushing_trap_entity",
                    location: location,
                    minDistance: 0,
                    maxDistance: 0
                });
                if (crushing_trap.length === 0) {
                    crushing_trapPlace({ block, dimension });
                } else {
                    crushing_trap.forEach(entity => {
                        dimension.setBlockType({ x: block.location.x + x, y: block.location.y, z: block.location.z + z }, "minecraft:barrier");
                        entity.setProperty("crafting_traps:crushing_trap", true);
                        const hasPlayedSound = block.permutation.getState("crafting_traps:played_sound");
                        if (!hasPlayedSound) {
                            entity.runCommand(`playsound block.crushing_trap.on_off @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
                            block.setPermutation(block.permutation.withState("crafting_traps:played_sound", true));
                        }
                        system.runTimeout(() => {
                            for (let yOffset = 0; yOffset >= -1; yOffset--) {
                                dimension.getEntities({
                                    excludeFamilies: ['inanimate'],
                                    minDistance: 0,
                                    maxDistance: 1,
                                    location: {
                                        x: block.location.x + x + 0.5,
                                        y: block.location.y + yOffset,
                                        z: block.location.z + z + 0.5
                                    }
                                }).forEach(entityDamage => {
                                    entityDamage.applyDamage(1);
                                });
                            }
                        }, 60);
                    });
                }
            }
        }
    }
    if (!foundActive) {
        const crushing_trap = dimension.getEntities({
            type: "crafting_traps:crushing_trap_entity",
            location: location,
            minDistance: 0,
            maxDistance: 0
        });
        if (crushing_trap.length === 0) {
            crushing_trapPlace({ block, dimension });
        } else {
            crushing_trap.forEach(entity => {
                const hasPlayedSound = block.permutation.getState("crafting_traps:played_sound");
                if (hasPlayedSound) {
                    entity.runCommand(`playsound block.crushing_trap.on_off @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
                    block.setPermutation(block.permutation.withState("crafting_traps:played_sound", true));
                }
                block.setPermutation(block.permutation.withState("crafting_traps:played_sound", false));
                system.runTimeout(() => {
                    const barrier = dimension.getBlock({ x: block.location.x + x, y: block.location.y, z: block.location.z + z });
                    if (barrier && barrier.typeId === "minecraft:barrier") {
                        dimension.setBlockType({ x: block.location.x + x, y: block.location.y, z: block.location.z + z }, "minecraft:air");
                    }
                }, 60);
                entity.setProperty("crafting_traps:crushing_trap", false);
            });
        }
    }
}

function crushing_trapPlace(data) {
    const { block, dimension } = data;
    block.setPermutation(block.permutation.withState("crafting_traps:place", true));
    const location = { x: block.location.x + 0.5, y: block.location.y, z: block.location.z + 0.5 }
    const direction = block.permutation.getState("minecraft:cardinal_direction");
    let rotationY = 0;
    switch (direction) {
        case 'north':
            rotationY = 0;
            break;
        case 'south':
            rotationY = 1;
            break;
        case 'west':
            rotationY = 2;
            break;
        case 'east':
            rotationY = 3;
            break;
    }

    const entity = dimension.spawnEntity(`crafting_traps:crushing_trap_entity`, location);
    entity.setProperty("crafting_traps:rotation", rotationY);
}

function thief_trap(data) {
    const { block, dimension } = data;
    const location = { x: block.location.x + 0.5, y: block.location.y + 2, z: block.location.z + 0.5 };
    const thief = dimension.getEntities({
        location: location,
        minDistance: 0,
        maxDistance: 1
    });
    thief.forEach(entity => {
        const equipmentCompPlayer = entity.getComponent(EntityComponentTypes.Equippable);
        if (!equipmentCompPlayer) return;
        const heldItem = equipmentCompPlayer.getEquipment("Mainhand");
        if (heldItem) {
            const chestLocation = { x: block.location.x, y: block.location.y - 1, z: block.location.z };
            const chest = dimension.getBlock(chestLocation);
            const inventory = chest.getComponent("minecraft:inventory");
            if (!inventory) return;
            const container = inventory.container
            container.addItem(heldItem.clone());
            equipmentCompPlayer.setEquipment("Mainhand", null);
            entity.runCommand(`playsound block.thief_trap.step @a[r=4] ${block.location.x} ${block.location.y} ${block.location.z} 1 1`);
        }
    });
}


function handleItemUseOn(event) {
    const { itemStack: item, block, source } = event;
    if (item.typeId === "minecraft:bucket" && block.typeId === "minecraft:powder_snow") {
        const itemClone = item.clone();
        const inventory = source.getComponent("minecraft:inventory");
        for (let i = 0; i < inventory.container.size; i++) {
            const slot = inventory.container.getItem(i);
            if (slot.typeId === "minecraft:powder_snow_bucket") {
                inventory.container.setItem(i, null);
                break;
            }
        }
        inventory.container.setItem(source.selectedSlotIndex, itemClone);
    }
}

function onPlayerInteract(event) {
    const { block, player, dimension } = event;
    explosiveMineBlock2(dimension, player);
}

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    const registry = initEvent.blockComponentRegistry;
    if (registry) {
        registry.registerCustomComponent('crafting_traps:onuse', {
            onPlayerInteract: onPlayerInteract
        });
        registry.registerCustomComponent('crafting_traps:onstep', {
            onStepOn: onstep
        });
        registry.registerCustomComponent('crafting_traps:onstepoff', {
            onStepOff: onstepOff
        });
        registry.registerCustomComponent('crafting_traps:crushing_trap', {
            onTick: crushing_trap
        });
        registry.registerCustomComponent('crafting_traps:thief_trap', {
            onTick: thief_trap
        });
        registry.registerCustomComponent('crafting_traps:crushing_trap_place', {
            onPlace: crushing_trapPlace
        });
    }
});

world.afterEvents.itemUseOn.subscribe(handleItemUseOn);

world.afterEvents.playerBreakBlock.subscribe((event) => {
    const { player, block, brokenBlockPermutation, dimension } = event;
    if (brokenBlockPermutation.type.id !== 'crafting_traps:crushing_trap') return;
    const direction = brokenBlockPermutation.getState("minecraft:cardinal_direction");
    let x = 0;
    let z = 0;
    switch (direction) {
        case 'north':
            x = 0;
            z = 1;
            break;
        case 'south':
            x = 0;
            z = -1;
            break;
        case 'west':
            x = 1;
            z = 0;
            break;
        case 'east':
            x = -1;
            z = 0;
            break;
    }
    const barrier = dimension.getBlock({ x: block.location.x + x, y: block.location.y, z: block.location.z + z });
    if (barrier && barrier.typeId === "minecraft:barrier") {
        dimension.setBlockType({ x: block.location.x + x, y: block.location.y, z: block.location.z + z }, "minecraft:air");
    }
    const location = { x: block.location.x + 0.5, y: block.location.y, z: block.location.z + 0.5 };
    const crushing_trap_entity = dimension.getEntities({
        type: "crafting_traps:crushing_trap_entity",
        location: location,
        minDistance: 0,
        maxDistance: 0
    });
    crushing_trap_entity.forEach(entity => {
        entity.remove();
    });
});

function spike() {
    const dimensions = ["overworld", "nether", "the_end"];
    dimensions.forEach(dimensionName => {
        const dimension = world.getDimension(dimensionName);
        dimension.getEntities().forEach(entity => {
            const y = entity.location.y;

            // Verificación de altura según la dimensión
            if ((entity.dimension.typeId === "minecraft:overworld" && y >= -63 && y <= 319) || 
                (entity.dimension.typeId !== "minecraft:overworld" && y >= 1 && y <= 125)) {
                
                const spikeBlock = dimension.getBlock({ x: entity.location.x, y: y, z: entity.location.z });
                let lastSoundTick = entity.getDynamicProperty("lastSpikeSoundTick") || 0;
                let currentTick = system.currentTick;

                if (spikeBlock && spikeBlock.typeId === 'crafting_traps:spike') {
                    if (currentTick - lastSoundTick >= 10) {
                        entity.runCommand(`playsound block.spike.step @a[r=4] ${spikeBlock.location.x} ${spikeBlock.location.y} ${spikeBlock.location.z} 1 1`);
                        entity.setDynamicProperty("lastSpikeSoundTick", currentTick);
                    }
                    entity.applyDamage(1, { cause: "contact" });
                }

                if (spikeBlock && spikeBlock.typeId === 'crafting_traps:poisonous_spike') {
                    if (currentTick - lastSoundTick >= 10) {
                        entity.runCommand(`playsound block.spike_poison.step @a[r=4] ${spikeBlock.location.x} ${spikeBlock.location.y} ${spikeBlock.location.z} 1 1`);
                        entity.setDynamicProperty("lastSpikeSoundTick", currentTick);
                    }
                    entity.addEffect("poison", 60, { amplifier: 1, showParticles: true });
                    entity.applyDamage(1, { cause: "contact" });
                }
            }
        });
    });
}


function quicksand() {
    const dimensions = ["overworld", "nether", "the_end"];
    dimensions.forEach(dimensionName => {
        const dimension = world.getDimension(dimensionName);
        dimension.getEntities().forEach(entity => {
            if (entity.typeId === 'minecraft:player' && entity.getGameMode() !== "survival") return;
            const y = entity.location.y;

            // Verificación de altura según la dimensión
            if ((entity.dimension.typeId === "minecraft:overworld" && y >= -63 && y <= 319) || 
                (entity.dimension.typeId !== "minecraft:overworld" && y >= 1 && y <= 125)) {
                
                const headLocation = entity.getHeadLocation();
                const quicksandBlockBelow = dimension.getBlock({ x: entity.location.x, y: y - 0.02, z: entity.location.z });
                const quicksandBlockAt = dimension.getBlock({ x: entity.location.x, y: y, z: entity.location.z });

                if (quicksandBlockBelow && quicksandBlockBelow.typeId === 'crafting_traps:quicksand') {
                    const newY = y - 0.02;
                    entity.teleport({ x: entity.location.x, y: newY, z: entity.location.z });
                }

                if (quicksandBlockAt && quicksandBlockAt.typeId === 'crafting_traps:quicksand') {
                    const airBlockAboveHead = dimension.getBlock({ x: headLocation.x, y: headLocation.y, z: headLocation.z });
                    if (!airBlockAboveHead || airBlockAboveHead.typeId !== 'minecraft:air') {
                        let lastSoundTick = entity.getDynamicProperty("lastQuicksandSoundTick") || 0;
                        let currentTick = system.currentTick;
                        if (currentTick - lastSoundTick >= 10) {
                            system.runTimeout(() => {
                                if (entity) {
                                    entity.runCommand(`playsound block.quicksand.sink @a[r=4] ${entity.location.x} ${entity.location.y} ${entity.location.z} 1 1`);
                                }
                            }, 10);
                            entity.setDynamicProperty("lastQuicksandSoundTick", currentTick);
                        }
                        entity.addEffect("darkness", 20, { amplifier: 255, showParticles: false });
                        entity.addEffect("blindness", 80, { amplifier: 255, showParticles: false });
                        entity.applyDamage(1, { cause: "contact" });
                    }
                }
            }
        });
    });
}


function explosiveMine() {
    const dimensions = ["overworld", "nether", "the_end"];
    dimensions.forEach(dimensionName => {
        const dimension = world.getDimension(dimensionName);
        dimension.getEntities().forEach(entity => {
            const y = entity.location.y;

            // Verificación de altura según la dimensión
            if ((entity.dimension.typeId === "minecraft:overworld" && y >= -63 && y <= 319) || 
                (entity.dimension.typeId !== "minecraft:overworld" && y >= 1 && y <= 125)) {
                
                const mineBlock = dimension.getBlock({ x: entity.location.x, y: y, z: entity.location.z });
                if (mineBlock && mineBlock.typeId === 'crafting_traps:explosive_mine') {
                    entity.runCommand(`playsound block.mine.beep @a[r=4] ${mineBlock.location.x} ${mineBlock.location.y} ${mineBlock.location.z} 1 1`);
                    const mineDummy = dimension.spawnEntity("crafting_traps:minedummy", {
                        x: entity.location.x,
                        y: entity.location.y,
                        z: entity.location.z
                    });
                }
            }
        });
    });
}


function explosiveMineBlock2(dimension, player) {
    player.runCommand(`playsound block.mine.beep @a[r=4] ${player.location.x} ${player.location.y} ${player.location.z} 1 1`);
    const mineDummy = dimension.spawnEntity("crafting_traps:minedummy", {
        x: player.location.x,
        y: player.location.y,
        z: player.location.z
    });
}

function explosiveMineBlock(dimension, entity) {
    entity.runCommand(`playsound block.mine.beep @a[r=4] ${entity.location.x} ${entity.location.y} ${entity.location.z} 1 1`);
    const mineDummy = dimension.spawnEntity("crafting_traps:minedummy", {
        x: entity.location.x,
        y: entity.location.y,
        z: entity.location.z
    });
}

system.runInterval(() => {
    replaceMissingBlocks();
    gas();
    spike();
    quicksand();
    explosiveMine();
});
